<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Processors/Linker.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Processors/Linker.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Processors/Linker.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Composite, Parameter</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.QualifiedName <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processors <span class="py-keyword">import</span> TemplateLinker</span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html">Linker</a>(Composite, ASG.Visitor):</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Visitor that removes duplicate declarations&quot;&quot;&quot;</span></span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">   remove_empty_modules = Parameter(True, <span class="py-string">'Remove empty modules.'</span>)</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">   sort_modules = Parameter(True, <span class="py-string">'Sort module content alphabetically.'</span>)</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">   sxr_prefix = Parameter(<span class="py-string">''</span>, <span class="py-string">'Compile sxr data, if defined.'</span>)</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#process">process</a>(self, ir, **kwds):</span>
<a id="line22"></a><span class="lineno"> 22</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">      self.set_parameters(kwds)</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">      self.ir = self.merge_input(ir)</span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">      root = ASG.MetaModule(<span class="py-string">&quot;&quot;</span>, QualifiedName())</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">      self.__scopes = [root]</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">      global_dict = {}</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">      self.__dict_map = {id(root) : global_dict}</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">      self.__dicts = [global_dict]</span>
<a id="line31"></a><span class="lineno"> 31</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">      self.types = self.ir.asg.types</span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">      <span class="py-keyword">try</span>:</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">         <span class="py-keyword">for</span> d <span class="py-keyword">in</span> self.ir.asg.declarations:</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">            d.accept(self)</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">         self.ir.asg.declarations = root.declarations</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">      <span class="py-keyword">except</span> TypeError, e:</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">         <span class="py-keyword">import</span> traceback</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">         traceback.print_exc()</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">         <span class="py-keyword">print</span> <span class="py-string">'linker error :'</span>, e</span>
<a id="line42"></a><span class="lineno"> 42</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">      <span class="py-keyword">for</span> file <span class="py-keyword">in</span> self.ir.files.values():</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">         self.visit_source_file(file)</span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">      self.ir = TemplateLinker.TemplateLinker().process(self.ir, debug=self.debug)</span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">      <span class="py-keyword">if</span> self.remove_empty_modules:</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">         <span class="py-keyword">import</span> ModuleFilter</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">         self.ir = ModuleFilter.ModuleFilter().process(self.ir, debug=self.debug)</span>
<a id="line51"></a><span class="lineno"> 51</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">      <span class="py-keyword">if</span> self.sort_modules:</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">         <span class="py-keyword">import</span> ModuleSorter</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">         self.ir = ModuleSorter.ModuleSorter().process(self.ir, debug=self.debug)</span>
<a id="line55"></a><span class="lineno"> 55</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">      <span class="py-keyword">if</span> self.sxr_prefix:</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">         <span class="py-keyword">import</span> SXRCompiler</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">         sxrcompiler = SXRCompiler.SXRCompiler(prefix=self.sxr_prefix)</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">         self.ir = sxrcompiler.process(self.ir, debug=self.debug)</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">      <span class="py-comment"># now deal with the sub-processors, if any</span></span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">      output = self.output</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">      self.ir = Composite.process(self, self.ir, input=[], output=<span class="py-string">''</span>)</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">      self.output = output</span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">      <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line67"></a><span class="lineno"> 67</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#lookup">lookup</a>(self, name):</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">      <span class="py-string">&quot;&quot;&quot;look whether the current scope already contains</span></span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line"><span class="py-string">      a declaration with the given name&quot;&quot;&quot;</span></span>
<a id="line71"></a><span class="lineno"> 71</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">      <span class="py-keyword">return</span> self.__dicts[-1].get(name)</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#append">append</a>(self, declaration):</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">      <span class="py-string">&quot;&quot;&quot;append declaration to the current scope&quot;&quot;&quot;</span></span>
<a id="line76"></a><span class="lineno"> 76</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">      self.__scopes[-1].declarations.append(declaration)</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">      self.__dicts[-1][declaration.name] = declaration</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#push">push</a>(self, scope):</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">      <span class="py-string">&quot;&quot;&quot;push new scope on the stack&quot;&quot;&quot;</span></span>
<a id="line82"></a><span class="lineno"> 82</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">      self.__scopes.append(scope)</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">      dict = self.__dict_map.setdefault(id(scope), {})</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">      self.__dicts.append(dict)</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#pop">pop</a>(self):</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">      <span class="py-string">&quot;&quot;&quot;restore the previous scope&quot;&quot;&quot;</span></span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">      <span class="py-keyword">del</span> self.__scopes[-1]</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">      <span class="py-keyword">del</span> self.__dicts[-1]</span>
<a id="line92"></a><span class="lineno"> 92</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#top">top</a>(self):</span>
<a id="line94"></a><span class="lineno"> 94</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">      <span class="py-keyword">return</span> self.__scopes[-1]</span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#top_dict">top_dict</a>(self):</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">      <span class="py-keyword">return</span> self.__dicts[-1]</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#link_type">link_type</a>(self, type):</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">      <span class="py-string">&quot;Returns the same or new proxy type&quot;</span></span>
<a id="line103"></a><span class="lineno">103</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">      self.__type = type</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">      <span class="py-keyword">if</span> type <span class="py-keyword">is</span> <span class="py-keyword">not</span> None: type.accept(self)</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">      <span class="py-keyword">return</span> self.__type</span>
<a id="line107"></a><span class="lineno">107</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">   <span class="py-comment">#################### Type Visitor ###########################################</span></span>
<a id="line109"></a><span class="lineno">109</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_builtin_type_id">visit_builtin_type_id</a>(self, type):</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">      <span class="py-keyword">if</span> self.types.has_key(type.name):</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">         self.__type = self.types[type.name]</span>
<a id="line114"></a><span class="lineno">114</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_unknown_type_id">visit_unknown_type_id</a>(self, type):</span>
<a id="line116"></a><span class="lineno">116</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">      <span class="py-keyword">if</span> self.types.has_key(type.name):</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">         self.__type = self.types[type.name]</span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_declared_type_id">visit_declared_type_id</a>(self, type):</span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">      <span class="py-keyword">if</span> self.types.has_key(type.name):</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">         self.__type = self.types[type.name]</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">         <span class="py-keyword">print</span> <span class="py-string">&quot;Couldn't find declared type-id:&quot;</span>,type.name</span>
<a id="line126"></a><span class="lineno">126</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_template_id">visit_template_id</a>(self, type):</span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">      <span class="py-comment"># Should be a Declared with the same name</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line">      <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.types.has_key(type.name):</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">         <span class="py-keyword">return</span></span>
<a id="line132"></a><span class="lineno">132</span><span class="line">      declared = self.types[type.name]</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">      <span class="py-keyword">if</span> isinstance(declared, ASG.UnknownTypeId):</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">         <span class="py-comment">#the type was declared in a file for which no ASG is retained</span></span>
<a id="line135"></a><span class="lineno">135</span><span class="line">         <span class="py-keyword">return</span></span>
<a id="line136"></a><span class="lineno">136</span><span class="line">      <span class="py-keyword">elif</span> <span class="py-keyword">not</span> isinstance(declared, ASG.DeclaredTypeId):</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">         <span class="py-keyword">print</span> <span class="py-string">&quot;Warning: template declaration was not a declaration:&quot;</span>,type.name,declared.__class__.__name__</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">         <span class="py-keyword">return</span></span>
<a id="line139"></a><span class="lineno">139</span><span class="line">      decl = declared.declaration</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">      <span class="py-keyword">if</span> <span class="py-keyword">not</span> hasattr(decl, <span class="py-string">'template'</span>):</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">         <span class="py-comment">#print &quot;Warning: non-class/function template&quot;,type.name, decl.__class__.__name__</span></span>
<a id="line142"></a><span class="lineno">142</span><span class="line">         <span class="py-keyword">return</span></span>
<a id="line143"></a><span class="lineno">143</span><span class="line">      <span class="py-keyword">if</span> decl.template:</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">         self.__type = decl.template</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">         <span class="py-keyword">print</span> <span class="py-string">&quot;Warning: template type disappeared:&quot;</span>,type.name</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_modifier_type_id">visit_modifier_type_id</a>(self, type):</span>
<a id="line149"></a><span class="lineno">149</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">      alias = self.link_type(type.alias)</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">      <span class="py-keyword">if</span> alias <span class="py-keyword">is</span> <span class="py-keyword">not</span> type.alias:</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">         type.alias = alias</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">      self.__type = type</span>
<a id="line154"></a><span class="lineno">154</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_array_type_id">visit_array_type_id</a>(self, type):</span>
<a id="line156"></a><span class="lineno">156</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">      alias = self.link_type(type.alias)</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">      <span class="py-keyword">if</span> alias <span class="py-keyword">is</span> <span class="py-keyword">not</span> type.alias:</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">         type.alias = alias</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">      self.__type = type</span>
<a id="line161"></a><span class="lineno">161</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_parametrized_type_id">visit_parametrized_type_id</a>(self, type):</span>
<a id="line163"></a><span class="lineno">163</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">      templ = self.link_type(type.template)</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">      <span class="py-keyword">if</span> templ <span class="py-keyword">is</span> <span class="py-keyword">not</span> type.template:</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">         type.template = templ</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">      type.parameters = [self.link_type(p) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters]</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">      self.__type = type</span>
<a id="line169"></a><span class="lineno">169</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_function_type_id">visit_function_type_id</a>(self, type):</span>
<a id="line171"></a><span class="lineno">171</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">      ret = self.link_type(type.return_type)</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">      <span class="py-keyword">if</span> ret <span class="py-keyword">is</span> <span class="py-keyword">not</span> type.return_type:</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">         type.return_type = ret</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">      type.parameters = [self.link_type(p) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters]</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">      self.__type = type</span>
<a id="line177"></a><span class="lineno">177</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">   <span class="py-comment">#################### ASG Visitor ############################################</span></span>
<a id="line179"></a><span class="lineno">179</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_source_file">visit_source_file</a>(self, file):</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Resolves any duplicates in the list of declarations from this</span></span>
<a id="line182"></a><span class="lineno">182</span><span class="line"><span class="py-string">      file&quot;&quot;&quot;</span></span>
<a id="line183"></a><span class="lineno">183</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">      types = self.types</span>
<a id="line185"></a><span class="lineno">185</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">      <span class="py-comment"># Clear the list and refill it</span></span>
<a id="line187"></a><span class="lineno">187</span><span class="line">      declarations = file.declarations</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">      file.declarations = []</span>
<a id="line189"></a><span class="lineno">189</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations:</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">         <span class="py-comment"># If this is a forward declaration try to</span></span>
<a id="line192"></a><span class="lineno">192</span><span class="line">         <span class="py-comment"># replace it by the definition...</span></span>
<a id="line193"></a><span class="lineno">193</span><span class="line">         <span class="py-keyword">if</span> types.has_key(d.name):</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">            declared = types[d.name]</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">            <span class="py-keyword">if</span> isinstance(declared, ASG.DeclaredTypeId):</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">               d = declared.declaration</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">         <span class="py-comment"># ...and only declare it once.</span></span>
<a id="line198"></a><span class="lineno">198</span><span class="line">         <span class="py-keyword">if</span> d <span class="py-keyword">not</span> <span class="py-keyword">in</span> file.declarations:</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">            file.declarations.append(d)</span>
<a id="line200"></a><span class="lineno">200</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">      <span class="py-comment"># TODO: includes.</span></span>
<a id="line202"></a><span class="lineno">202</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_module">visit_module</a>(self, module):</span>
<a id="line204"></a><span class="lineno">204</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">      <span class="py-comment">#hmm, we assume that the parent node is a MetaModule. Can that ever fail ?</span></span>
<a id="line206"></a><span class="lineno">206</span><span class="line">      metamodule = self.lookup(module.name)</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">      <span class="py-keyword">if</span> metamodule <span class="py-keyword">is</span> None:</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">         metamodule = ASG.MetaModule(module.type,module.name)</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">         self.append(metamodule)</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">      <span class="py-keyword">elif</span> <span class="py-keyword">not</span> isinstance(metamodule, ASG.MetaModule):</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">         <span class="py-keyword">raise</span> TypeError, <span class="py-string">'symbol type mismatch: Synopsis.ASG.Module and %s both match &quot;%s&quot;'</span>%(metamodule.__class__, str(module.name))</span>
<a id="line212"></a><span class="lineno">212</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">      metamodule.module_declarations.append(module)</span>
<a id="line214"></a><span class="lineno">214</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">      <span class="py-comment"># Merge comments.</span></span>
<a id="line216"></a><span class="lineno">216</span><span class="line">      self.merge_comments(metamodule, module)</span>
<a id="line217"></a><span class="lineno">217</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">      self.push(metamodule)</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> module.declarations:</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">         d.accept(self)</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">      module.declarations = []</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">      self.pop()</span>
<a id="line223"></a><span class="lineno">223</span>
<a id="line224"></a><span class="lineno">224</span>
<a id="line225"></a><span class="lineno">225</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_group">visit_group</a>(self, group):</span>
<a id="line226"></a><span class="lineno">226</span>
<a id="line227"></a><span class="lineno">227</span><span class="line">      previous = self.lookup(group.name)</span>
<a id="line228"></a><span class="lineno">228</span><span class="line">      <span class="py-keyword">if</span> <span class="py-keyword">not</span> previous:</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">         self.append(group)</span>
<a id="line230"></a><span class="lineno">230</span><span class="line">      <span class="py-keyword">elif</span> isinstance(previous, ASG.Group):</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">         previous.declarations.append(group.declarations)</span>
<a id="line232"></a><span class="lineno">232</span><span class="line">         self.merge_comments(previous, group)</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">         group = previous</span>
<a id="line234"></a><span class="lineno">234</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line235"></a><span class="lineno">235</span><span class="line">         <span class="py-keyword">raise</span> TypeError, <span class="py-string">'symbol type mismatch: Synopsis.ASG.Group and %s both match &quot;%s&quot;'</span>%(previous.__class__, str(previous.name))</span>
<a id="line236"></a><span class="lineno">236</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">      self.push(group)</span>
<a id="line238"></a><span class="lineno">238</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> group.declarations:</span>
<a id="line239"></a><span class="lineno">239</span><span class="line">         d.accept(self)</span>
<a id="line240"></a><span class="lineno">240</span><span class="line">      self.pop()</span>
<a id="line241"></a><span class="lineno">241</span>
<a id="line242"></a><span class="lineno">242</span>
<a id="line243"></a><span class="lineno">243</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#merge_comments">merge_comments</a>(self, metamodule, module):</span>
<a id="line244"></a><span class="lineno">244</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Append the module comments into the metamodule.&quot;&quot;&quot;</span></span>
<a id="line245"></a><span class="lineno">245</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">      <span class="py-keyword">if</span> module.annotations.has_key(<span class="py-string">'comments'</span>):</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">         new_comments = module.annotations[<span class="py-string">'comments'</span>]</span>
<a id="line248"></a><span class="lineno">248</span><span class="line">         metamodule.annotations.setdefault(<span class="py-string">'comments'</span>, [])</span>
<a id="line249"></a><span class="lineno">249</span><span class="line">         comments = metamodule.annotations[<span class="py-string">'comments'</span>]</span>
<a id="line250"></a><span class="lineno">250</span><span class="line">         <span class="py-keyword">if</span> comments[-len(new_comments):] != new_comments:</span>
<a id="line251"></a><span class="lineno">251</span><span class="line">            comments.extend(new_comments)</span>
<a id="line252"></a><span class="lineno">252</span>
<a id="line253"></a><span class="lineno">253</span>
<a id="line254"></a><span class="lineno">254</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_meta_module">visit_meta_module</a>(self, module):</span>
<a id="line255"></a><span class="lineno">255</span>
<a id="line256"></a><span class="lineno">256</span><span class="line">      <span class="py-comment">#hmm, we assume that the parent node is a MetaModule. Can that ever fail ?</span></span>
<a id="line257"></a><span class="lineno">257</span><span class="line">      metamodule = self.lookup(module.name)</span>
<a id="line258"></a><span class="lineno">258</span><span class="line">      <span class="py-keyword">if</span> metamodule <span class="py-keyword">is</span> None:</span>
<a id="line259"></a><span class="lineno">259</span><span class="line">         metamodule = ASG.MetaModule(module.type,module.name)</span>
<a id="line260"></a><span class="lineno">260</span><span class="line">         self.append(metamodule)</span>
<a id="line261"></a><span class="lineno">261</span><span class="line">      <span class="py-keyword">elif</span> <span class="py-keyword">not</span> isinstance(metamodule, ASG.MetaModule):</span>
<a id="line262"></a><span class="lineno">262</span><span class="line">         <span class="py-keyword">raise</span> TypeError, <span class="py-string">'symbol type mismatch: Synopsis.ASG.MetaModule and %s both match &quot;%s&quot;'</span>%(metamodule.__class__, <span class="py-string">'::'</span>.join(module.name))</span>
<a id="line263"></a><span class="lineno">263</span>
<a id="line264"></a><span class="lineno">264</span><span class="line">      metamodule.module_declarations.extend(module.module_declarations)</span>
<a id="line265"></a><span class="lineno">265</span><span class="line">      self.merge_comments(metamodule, module)</span>
<a id="line266"></a><span class="lineno">266</span><span class="line">      self.push(metamodule)</span>
<a id="line267"></a><span class="lineno">267</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> module.declarations:</span>
<a id="line268"></a><span class="lineno">268</span><span class="line">         d.accept(self)</span>
<a id="line269"></a><span class="lineno">269</span><span class="line">      module.declarations = []</span>
<a id="line270"></a><span class="lineno">270</span><span class="line">      self.pop()</span>
<a id="line271"></a><span class="lineno">271</span>
<a id="line272"></a><span class="lineno">272</span>
<a id="line273"></a><span class="lineno">273</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#add_declaration">add_declaration</a>(self, decl):</span>
<a id="line274"></a><span class="lineno">274</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Adds a declaration to the current (top) scope.</span></span>
<a id="line275"></a><span class="lineno">275</span><span class="line"><span class="py-string">      If there is already a Forward declaration, then this replaces it</span></span>
<a id="line276"></a><span class="lineno">276</span><span class="line"><span class="py-string">      unless this is also a Forward.</span></span>
<a id="line277"></a><span class="lineno">277</span><span class="line"><span class="py-string">      &quot;&quot;&quot;</span></span>
<a id="line278"></a><span class="lineno">278</span>
<a id="line279"></a><span class="lineno">279</span><span class="line">      name = decl.name</span>
<a id="line280"></a><span class="lineno">280</span><span class="line">      dict = self.__dicts[-1]</span>
<a id="line281"></a><span class="lineno">281</span><span class="line">      decls = self.top().declarations</span>
<a id="line282"></a><span class="lineno">282</span><span class="line">      <span class="py-keyword">if</span> dict.has_key(name):</span>
<a id="line283"></a><span class="lineno">283</span><span class="line">         prev = dict[name]</span>
<a id="line284"></a><span class="lineno">284</span><span class="line">         <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(prev, ASG.Forward):</span>
<a id="line285"></a><span class="lineno">285</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line286"></a><span class="lineno">286</span><span class="line">         <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(decl, ASG.Forward):</span>
<a id="line287"></a><span class="lineno">287</span><span class="line">            decls.remove(prev)</span>
<a id="line288"></a><span class="lineno">288</span><span class="line">            decls.append(decl)</span>
<a id="line289"></a><span class="lineno">289</span><span class="line">            dict[name] = decl <span class="py-comment"># overwrite prev</span></span>
<a id="line290"></a><span class="lineno">290</span><span class="line">         <span class="py-keyword">return</span></span>
<a id="line291"></a><span class="lineno">291</span><span class="line">      decls.append(decl)</span>
<a id="line292"></a><span class="lineno">292</span><span class="line">      dict[name] = decl</span>
<a id="line293"></a><span class="lineno">293</span>
<a id="line294"></a><span class="lineno">294</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_builtin">visit_builtin</a>(self, builtin):</span>
<a id="line295"></a><span class="lineno">295</span><span class="line">      <span class="py-string">&quot;&quot;&quot;preserve builtins unconditionally&quot;&quot;&quot;</span></span>
<a id="line296"></a><span class="lineno">296</span>
<a id="line297"></a><span class="lineno">297</span><span class="line">      self.top().declarations.append(builtin)</span>
<a id="line298"></a><span class="lineno">298</span>
<a id="line299"></a><span class="lineno">299</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_named_type">visit_named_type</a>(self, decl):</span>
<a id="line300"></a><span class="lineno">300</span>
<a id="line301"></a><span class="lineno">301</span><span class="line">      name = decl.name</span>
<a id="line302"></a><span class="lineno">302</span><span class="line">      <span class="py-keyword">if</span> self.lookup(decl.name): <span class="py-keyword">return</span></span>
<a id="line303"></a><span class="lineno">303</span><span class="line">      self.add_declaration(decl)</span>
<a id="line304"></a><span class="lineno">304</span>
<a id="line305"></a><span class="lineno">305</span><span class="line">   visit_declaration = add_declaration</span>
<a id="line306"></a><span class="lineno">306</span><span class="line">   visit_forward = add_declaration</span>
<a id="line307"></a><span class="lineno">307</span><span class="line">   visit_enum = add_declaration</span>
<a id="line308"></a><span class="lineno">308</span>
<a id="line309"></a><span class="lineno">309</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_function">visit_function</a>(self, func):</span>
<a id="line310"></a><span class="lineno">310</span><span class="line">      <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(self.top(), (ASG.Class, ASG.ClassTemplate)):</span>
<a id="line311"></a><span class="lineno">311</span><span class="line">         <span class="py-keyword">for</span> d <span class="py-keyword">in</span> self.top().declarations:</span>
<a id="line312"></a><span class="lineno">312</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(d, ASG.Function): <span class="py-keyword">continue</span></span>
<a id="line313"></a><span class="lineno">313</span><span class="line">            <span class="py-keyword">if</span> func.name == d.name:</span>
<a id="line314"></a><span class="lineno">314</span><span class="line">               <span class="py-keyword">return</span></span>
<a id="line315"></a><span class="lineno">315</span><span class="line">      ret = self.link_type(func.return_type)</span>
<a id="line316"></a><span class="lineno">316</span><span class="line">      <span class="py-keyword">if</span> ret <span class="py-keyword">is</span> <span class="py-keyword">not</span> func.return_type:</span>
<a id="line317"></a><span class="lineno">317</span><span class="line">         func.return_type = ret</span>
<a id="line318"></a><span class="lineno">318</span><span class="line">      <span class="py-keyword">for</span> param <span class="py-keyword">in</span> func.parameters:</span>
<a id="line319"></a><span class="lineno">319</span><span class="line">         self.visit_parameter(param)</span>
<a id="line320"></a><span class="lineno">320</span><span class="line">      self.top().declarations.append(func)</span>
<a id="line321"></a><span class="lineno">321</span>
<a id="line322"></a><span class="lineno">322</span>
<a id="line323"></a><span class="lineno">323</span><span class="line">   visit_operation = visit_function</span>
<a id="line324"></a><span class="lineno">324</span>
<a id="line325"></a><span class="lineno">325</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_variable">visit_variable</a>(self, var):</span>
<a id="line326"></a><span class="lineno">326</span>
<a id="line327"></a><span class="lineno">327</span><span class="line">      <span class="py-comment">#if not scopedNameOkay(var.name): return</span></span>
<a id="line328"></a><span class="lineno">328</span><span class="line">      vt = self.link_type(var.vtype)</span>
<a id="line329"></a><span class="lineno">329</span><span class="line">      <span class="py-keyword">if</span> vt <span class="py-keyword">is</span> <span class="py-keyword">not</span> var.vtype:</span>
<a id="line330"></a><span class="lineno">330</span><span class="line">         var.vtype = vt</span>
<a id="line331"></a><span class="lineno">331</span><span class="line">      self.add_declaration(var)</span>
<a id="line332"></a><span class="lineno">332</span>
<a id="line333"></a><span class="lineno">333</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_typedef">visit_typedef</a>(self, tdef):</span>
<a id="line334"></a><span class="lineno">334</span>
<a id="line335"></a><span class="lineno">335</span><span class="line">      alias = self.link_type(tdef.alias)</span>
<a id="line336"></a><span class="lineno">336</span><span class="line">      <span class="py-keyword">if</span> alias <span class="py-keyword">is</span> <span class="py-keyword">not</span> tdef.alias:</span>
<a id="line337"></a><span class="lineno">337</span><span class="line">         tdef.alias = alias</span>
<a id="line338"></a><span class="lineno">338</span><span class="line">      self.add_declaration(tdef)</span>
<a id="line339"></a><span class="lineno">339</span>
<a id="line340"></a><span class="lineno">340</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line341"></a><span class="lineno">341</span>
<a id="line342"></a><span class="lineno">342</span><span class="line">      prev = self.lookup(class_.name)</span>
<a id="line343"></a><span class="lineno">343</span><span class="line">      <span class="py-keyword">if</span> prev:</span>
<a id="line344"></a><span class="lineno">344</span><span class="line">         <span class="py-keyword">if</span> isinstance(prev, ASG.Forward):</span>
<a id="line345"></a><span class="lineno">345</span><span class="line">            <span class="py-comment"># Forward declaration, replace it</span></span>
<a id="line346"></a><span class="lineno">346</span><span class="line">            self.top().declarations.remove(prev)</span>
<a id="line347"></a><span class="lineno">347</span><span class="line">            <span class="py-keyword">del</span> self.top_dict()[class_.name]</span>
<a id="line348"></a><span class="lineno">348</span><span class="line">         <span class="py-keyword">elif</span> isinstance(prev, (ASG.Class, ASG.ClassTemplate)):</span>
<a id="line349"></a><span class="lineno">349</span><span class="line">            <span class="py-comment"># Previous class. Would ignore duplicate but class_ may have</span></span>
<a id="line350"></a><span class="lineno">350</span><span class="line">            <span class="py-comment"># class declarations that prev doesn't. (forward declared</span></span>
<a id="line351"></a><span class="lineno">351</span><span class="line">            <span class="py-comment"># nested -- see ThreadData.hh for example)</span></span>
<a id="line352"></a><span class="lineno">352</span><span class="line">            self.push(prev)</span>
<a id="line353"></a><span class="lineno">353</span><span class="line">            <span class="py-keyword">for</span> d <span class="py-keyword">in</span> class_.declarations:</span>
<a id="line354"></a><span class="lineno">354</span><span class="line">               <span class="py-keyword">if</span> isinstance(d, (ASG.Class, ASG.ClassTemplate)):</span>
<a id="line355"></a><span class="lineno">355</span><span class="line">                  d.accept(self)</span>
<a id="line356"></a><span class="lineno">356</span><span class="line">            self.pop()</span>
<a id="line357"></a><span class="lineno">357</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line358"></a><span class="lineno">358</span><span class="line">         <span class="py-keyword">else</span>:</span>
<a id="line359"></a><span class="lineno">359</span><span class="line">            <span class="py-keyword">raise</span> TypeError, <span class="py-string">'symbol type mismatch: Synopsis.ASG.Class and %s both match &quot;%s&quot;'</span>%(prev.__class__, <span class="py-string">'::'</span>.join(class_.name))</span>
<a id="line360"></a><span class="lineno">360</span><span class="line">      self.add_declaration(class_)</span>
<a id="line361"></a><span class="lineno">361</span><span class="line">      <span class="py-keyword">for</span> p <span class="py-keyword">in</span> class_.parents:</span>
<a id="line362"></a><span class="lineno">362</span><span class="line">         p.accept(self)</span>
<a id="line363"></a><span class="lineno">363</span><span class="line">      declarations = class_.declarations</span>
<a id="line364"></a><span class="lineno">364</span><span class="line">      class_.declarations = []</span>
<a id="line365"></a><span class="lineno">365</span><span class="line">      self.push(class_)</span>
<a id="line366"></a><span class="lineno">366</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations:</span>
<a id="line367"></a><span class="lineno">367</span><span class="line">         d.accept(self)</span>
<a id="line368"></a><span class="lineno">368</span><span class="line">      self.pop()</span>
<a id="line369"></a><span class="lineno">369</span>
<a id="line370"></a><span class="lineno">370</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_inheritance">visit_inheritance</a>(self, parent):</span>
<a id="line371"></a><span class="lineno">371</span>
<a id="line372"></a><span class="lineno">372</span><span class="line">      type = parent.parent</span>
<a id="line373"></a><span class="lineno">373</span><span class="line">      <span class="py-keyword">if</span> isinstance(type, (ASG.DeclaredTypeId, ASG.UnknownTypeId)):</span>
<a id="line374"></a><span class="lineno">374</span><span class="line">         ltype = self.link_type(type)</span>
<a id="line375"></a><span class="lineno">375</span><span class="line">         <span class="py-keyword">if</span> ltype <span class="py-keyword">is</span> <span class="py-keyword">not</span> type:</span>
<a id="line376"></a><span class="lineno">376</span><span class="line">            parent.parent = ltype</span>
<a id="line377"></a><span class="lineno">377</span><span class="line">      <span class="py-keyword">elif</span> isinstance(type, ASG.ParametrizedTypeId):</span>
<a id="line378"></a><span class="lineno">378</span><span class="line">         ltype = self.link_type(type.template)</span>
<a id="line379"></a><span class="lineno">379</span><span class="line">         <span class="py-keyword">if</span> ltype <span class="py-keyword">is</span> <span class="py-keyword">not</span> type.template:</span>
<a id="line380"></a><span class="lineno">380</span><span class="line">            <span class="py-comment"># Must find a ASG.TemplateId from it</span></span>
<a id="line381"></a><span class="lineno">381</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(ltype, ASG.DeclaredTypeId):</span>
<a id="line382"></a><span class="lineno">382</span><span class="line">               <span class="py-comment"># Error</span></span>
<a id="line383"></a><span class="lineno">383</span><span class="line">               <span class="py-keyword">return</span></span>
<a id="line384"></a><span class="lineno">384</span><span class="line">            decl = ltype.declaration</span>
<a id="line385"></a><span class="lineno">385</span><span class="line">            <span class="py-keyword">if</span> isinstance(decl, ASG.ClassTemplate):</span>
<a id="line386"></a><span class="lineno">386</span><span class="line">               type.template = decl.template</span>
<a id="line387"></a><span class="lineno">387</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line388"></a><span class="lineno">388</span><span class="line">         <span class="py-comment"># Unknown type in class inheritance</span></span>
<a id="line389"></a><span class="lineno">389</span><span class="line">         <span class="py-keyword">pass</span></span>
<a id="line390"></a><span class="lineno">390</span>
<a id="line391"></a><span class="lineno">391</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_parameter">visit_parameter</a>(self, param):</span>
<a id="line392"></a><span class="lineno">392</span>
<a id="line393"></a><span class="lineno">393</span><span class="line">      type = self.link_type(param.type)</span>
<a id="line394"></a><span class="lineno">394</span><span class="line">      <span class="py-keyword">if</span> type <span class="py-keyword">is</span> <span class="py-keyword">not</span> param.type:</span>
<a id="line395"></a><span class="lineno">395</span><span class="line">         param.type = type</span>
<a id="line396"></a><span class="lineno">396</span>
<a id="line397"></a><span class="lineno">397</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/Linker/Linker.html#visit_const">visit_const</a>(self, const):</span>
<a id="line398"></a><span class="lineno">398</span>
<a id="line399"></a><span class="lineno">399</span><span class="line">      ct = self.link_type(const.ctype)</span>
<a id="line400"></a><span class="lineno">400</span><span class="line">      <span class="py-keyword">if</span> ct <span class="py-keyword">is</span> <span class="py-keyword">not</span> const.ctype:</span>
<a id="line401"></a><span class="lineno">401</span><span class="line">         const.ctype = ct</span>
<a id="line402"></a><span class="lineno">402</span><span class="line">      self.add_declaration(const)</span>
<a id="line403"></a><span class="lineno">403</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
